Calculation Service

SpreadJS gives you the ability to suspend the evaluation of formulas and switch the calculation mode to manual using the calculate API.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

Suspend Calculation Service

Users can suspend the calculation service for a better experience when calling API in batches. For example:

spread.suspendPaint();
spread.suspendCalcService();
sheet.setFormula(0, 1, "SUM(A:A)");
for (var i = 0; i < 100; i++) {
    sheet.setValue(i, 0, i); // if not suspended, each setValue will calculate the B1 formula.
}
spread.resumeCalcService();
spread.resumePaint();

Calculation Options

SpreadJS supports a CalculationMode which can be set to manual or automatic.

Automatic Calculation (default) Calculate all dirty cells every time the relevant data is changed, like when something has been entered or copy-pasted in a cell.

Manual Calculation Only evaluate a formula when that formula is entered or updated, and keep its dependencies dirty. When cutting/copying-pasting, this mode will set the formula and the cell value, but won’t recalculate any formulas.

Calculate API

You can force calculation by calling the calculate API.
The Calculate function will rebuild, mark dirty, broadcast dirty and calculate the dirty cells.

  • First rebuild and mark cells in the formula reference as dirty using the calculation type. The list of `GC.Spread.Sheets.CalculationType` is as follows:
    • all - The default calculation type that mark cells in the range as dirty for calculation.
    • rebuild - Rebuild all the formula models in the range and then mark them as dirty for calculation.
    • minimal - Keep the current cell calculation dirty status.
    • regular - Mark the volatile and circular reference cells as dirty for calculation.
  • Broadcasting dirty cells will recursively set the dependents of dirty cells to dirty in the workbook.
  • The last step is calculate. In automatic mode, all the dirty cells will be calculated. In manual mode, only the cells in the formula reference are calculated, other cells will keep their dirty state.

For example:

 spread.sheets[0].setFormula(0,0,"RAND()");
 spread.sheets[0].setFormula(1,0,"=Sheet2!A1");
 spread.sheets[1].setFormula(0,0,"RAND()");
 spread.sheets[1].setFormula(1,0,"=Sheet1!A1");
 spread.calculate(GC.Spread.Sheets.CalculationType.all, "Sheet1"); // The Sheet1!A1 will generate a new random number, but Sheet2!A1 keeps th old value.  Sheet2!A2 keeps the old value when it's in manual calculation mode.
 spread.calculate(); // All the cells are recalculated.
Suspend Calculation Service Users can suspend the calculation service for a better experience when calling API in batches. For example: Calculation Options SpreadJS supports a CalculationMode which can be set to manual or automatic. Automatic Calculation (default) Calculate all dirty cells every time the relevant data is changed, like when something has been entered or copy-pasted in a cell. Manual Calculation Only evaluate a formula when that formula is entered or updated, and keep its dependencies dirty. When cutting/copying-pasting, this mode will set the formula and the cell value, but won’t recalculate any formulas. Calculate API You can force calculation by calling the calculate API. The Calculate function will rebuild, mark dirty, broadcast dirty and calculate the dirty cells. First rebuild and mark cells in the formula reference as dirty using the calculation type. The list of `GC.Spread.Sheets.CalculationType` is as follows: all - The default calculation type that mark cells in the range as dirty for calculation. rebuild - Rebuild all the formula models in the range and then mark them as dirty for calculation. minimal - Keep the current cell calculation dirty status. regular - Mark the volatile and circular reference cells as dirty for calculation. Broadcasting dirty cells will recursively set the dependents of dirty cells to dirty in the workbook. The last step is calculate. In automatic mode, all the dirty cells will be calculated. In manual mode, only the cells in the formula reference are calculated, other cells will keep their dirty state. For example:
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(_getElementById("ss")); initSpread(spread); }; function initSpread(spread) { var sheet = spread.getActiveSheet(); spread.setSheetCount(2); var sheet2 = spread.sheets[1]; spread.suspendPaint(); spread.suspendCalcService(); spread.options.iterativeCalculationMaximumIterations = 1; spread.options.iterativeCalculationMaximumChange = 10; sheet.setValue(0,0,"Tick:"); sheet.setFormula(0,1,"=REFRESH(B1+1,2,80)"); sheet.setValue(2,0,"Value:"); sheet.setFormula(2,1,"=IFERROR(CHOOSE(MOD(B1,16),5,-5,20,-2),0)+RAND()"); sheet.setValue(0,4,"Values:"); sheet.getRange(1,4,60,1).formula("=IF(MOD($B$1,60)=(ROW()-2),$B$3,E2)", true); sheet2.setValue(0,6,"Values:"); sheet2.getRange(1,6,60,1).formula("=OFFSET(Sheet1!$E$2,MOD(Sheet1!$B$1-1+ROW(),60),0)", true); sheet.setValue(1,6,'Value Sparkline:'); sheet.addSpan(2,6,6,6); sheet.setFormula(2,6,'=LINESPARKLINE(E2:E61,0,,,)'); sheet.setValue(10,6,'Sheet2 reorder values:'); sheet.addSpan(11,6,6,6); sheet.setFormula(11,6,'=LINESPARKLINE(Sheet2!G2:G61,0,,,)'); spread.resumeCalcService(); spread.resumePaint(); bindEvent(spread); } function bindEvent (spread) { _getElementById("enableCalcService").addEventListener('change', function () { if (this.checked) { spread.resumeCalcService(); } else { spread.suspendCalcService(); } }); _getElementById("calculationMode").addEventListener('change', function () { console.log(JSON.stringify(this.value)); if (this.value === "0") { spread.options.calculationMode = GC.Spread.Sheets.CalculationMode.auto; spread.calculate(false); } else { spread.options.calculationMode = GC.Spread.Sheets.CalculationMode.manual; } }); _getElementById("calculateSpread").addEventListener('click', function () { let type = _getElementById("calculationType").value; spread.calculate(GC.Spread.Sheets.CalculationType[type]); }); _getElementById("calculateSheet").addEventListener('click', function () { let type = _getElementById("calculationType").value; spread.calculate(GC.Spread.Sheets.CalculationType[type], spread.getActiveSheet().name()); }); _getElementById("calculateRange").addEventListener('click', function () { let type = _getElementById("calculationType").value; let sheet = spread.getActiveSheet(); let range = sheet.getSelections()[0]; spread.calculate(GC.Spread.Sheets.CalculationType[type], sheet.name()+"!"+GC.Spread.Sheets.CalcEngine.rangeToFormula(range)); }); } function _getElementById(id) { return document.getElementById(id); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="option-row"> <input style="width: 20px;float: left;" type="checkbox" id="enableCalcService" checked="checked"/> <label for="enableCalcService">enable Calculation Service</label> </div> <div class="option-row"> <p>Change the Calculation Mode and input formulas to see the calculation behavior. </p> <label for="calculationMode">Calculation Mode</label> <select id="calculationMode"> <option value="0">Automatic</option> <option value="1">Manual</option> </select> </div> <div class="option-row"> <p>Check the different calculate scopes with different calculation types in different calculation modes. </p> <label for="calculationType">Calculation Type</label> <select id="calculationType"> <option value="all">All</option> <option value="rebuild">Rebuild</option> <option value="minimal">Minimal</option> <option value="regular">Regular</option> </select> <button id="calculateSpread">Calculate Spread</button> <br /> <button id="calculateSheet">Calculate Sheet</button> <br /> <button id="calculateRange">Calculate Selection</button> </div> </div> </div></body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } input { margin-bottom: 5px; padding: 2px 4px; width: 100%; box-sizing: border-box; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

Suspend Calculation Service
Users can suspend the calculation service for a better experience when calling API in batches.
For example:
Calculation Options
SpreadJS supports a CalculationMode which can be set to manual or automatic.
Automatic Calculation (default)
Calculate all dirty cells every time the relevant data is changed, like when something has been entered or copy-pasted in a cell.
Manual Calculation
Only evaluate a formula when that formula is entered or updated, and keep its dependencies dirty. When cutting/copying-pasting, this mode will set the formula and the cell value, but won’t recalculate any formulas.
Calculate API
You can force calculation by calling the calculate API.
The Calculate function will rebuild, mark dirty, broadcast dirty and calculate the dirty cells.
First rebuild and mark cells in the formula reference as dirty using the calculation type. The list of `GC.Spread.Sheets.CalculationType` is as follows:
all - The default calculation type that mark cells in the range as dirty for calculation.
rebuild - Rebuild all the formula models in the range and then mark them as dirty for calculation.
minimal - Keep the current cell calculation dirty status.
regular - Mark the volatile and circular reference cells as dirty for calculation.
Broadcasting dirty cells will recursively set the dependents of dirty cells to dirty in the workbook.
The last step is calculate. In automatic mode, all the dirty cells will be calculated.
In manual mode, only the cells in the formula reference are calculated, other cells will keep their dirty state.
For example:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<input style="width: 20px;float: left;" type="checkbox" id="enableCalcService" checked="checked" @change="enableCalcService($event)"/>
<label for="enableCalcService">enable Calculation Service</label>
</div>
<div class="option-row">
<p>Change the Calculation Mode and input formulas to see the calculation behavior. </p>
<label for="calculationMode">Calculation Mode</label>
<select id="calculationMode" @change="calculationMode">
<option value="0">Automatic</option>
<option value="1">Manual</option>
</select>
</div>
<div class="option-row">
<p>Check the different calculate scopes with different calculation types in different calculation modes. </p>
<label for="changeType">Calculation Type</label>
<select id="changeType" @change="changeType">
<option value="all">All</option>
<option value="rebuild">Rebuild</option>
<option value="minimal">Minimal</option>
<option value="regular">Regular</option>
</select>
<button id="calculateSpread" @click="calculateSpread($event)" >Calculate Spread</button>
<br />
<button id="calculateSheet" @click="calculateSheet($event)" >Calculate Sheet</button>
<br />
<button id="calculateRange" @click="calculateRange($event)" >Calculate Selection</button>
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue';
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
const spreadRef = ref(null);
let calculationType;
let initSpread = function (spread) {
spreadRef.value = spread;
let sheet = spread.getActiveSheet();
spread.setSheetCount(2);
let sheet2 = spread.sheets[1];
spread.suspendPaint();
spread.suspendCalcService();
spread.options.iterativeCalculationMaximumIterations = 1;
spread.options.iterativeCalculationMaximumChange = 10;
sheet.setValue(0,0,"Tick:");
sheet.setFormula(0,1,"=REFRESH(B1+1,2,80)");
sheet.setValue(2,0,"Value:");
sheet.setFormula(2,1,"=IFERROR(CHOOSE(MOD(B1,16),5,-5,20,-2),0)+RAND()");
sheet.setValue(0,4,"Values:");
sheet.getRange(1,4,60,1).formula("=IF(MOD($B$1,60)=(ROW()-2),$B$3,E2)", true);
sheet2.setValue(0,6,"Values:");
sheet2.getRange(1,6,60,1).formula("=OFFSET(Sheet1!$E$2,MOD(Sheet1!$B$1-1+ROW(),60),0)", true);
sheet.setValue(1,6,'Value Sparkline:');
sheet.addSpan(2,6,6,6);
sheet.setFormula(2,6,'=LINESPARKLINE(E2:E61,0,,,)');
sheet.setValue(10,6,'Sheet2 reorder values:');
sheet.addSpan(11,6,6,6);
sheet.setFormula(11,6,'=LINESPARKLINE(Sheet2!G2:G61,0,,,)');
spread.resumeCalcService();
spread.resumePaint();
}
let enableCalcService = function (e) {
if (e.target.checked) {
spreadRef.value.resumeCalcService();
} else {
spreadRef.value.suspendCalcService();
}
}
let calculationMode = function (e) {
let spread = spreadRef.value;
if (e.target.value === "0") {
spread.options.calculationMode = GC.Spread.Sheets.CalculationMode.auto;
spread.calculate(false);
} else {
spread.options.calculationMode = GC.Spread.Sheets.CalculationMode.manual;
}
}
let changeType = function (e) {
calculationType = GC.Spread.Sheets.CalculationType[e.target.value];
}
let calculateSpread = function (e) {
spreadRef.value.calculate(calculationType);
}
let calculateSheet = function (e) {
spreadRef.value.calculate(calculationType, spreadRef.value.getActiveSheet().name());
}
let calculateRange = function (e) {
let sheet = spreadRef.value.getActiveSheet();
let range = sheet.getSelections()[0];
spreadRef.value.calculate(calculationType, sheet.name()+"!"+GC.Spread.Sheets.CalcEngine.rangeToFormula(range));
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
margin-bottom: 5px;
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

Suspend Calculation Service
Users can suspend the calculation service for a better experience when calling API in batches.
For example:
Calculation Options
SpreadJS supports a CalculationMode which can be set to manual or automatic.
Automatic Calculation (default)
Calculate all dirty cells every time the relevant data is changed, like when something has been entered or copy-pasted in a cell.
Manual Calculation
Only evaluate a formula when that formula is entered or updated, and keep its dependencies dirty. When cutting/copying-pasting, this mode will set the formula and the cell value, but won’t recalculate any formulas.
Calculate API
You can force calculation by calling the calculate API.
The Calculate function will rebuild, mark dirty, broadcast dirty and calculate the dirty cells.
First rebuild and mark cells in the formula reference as dirty using the calculation type. The list of `GC.Spread.Sheets.CalculationType` is as follows:
all - The default calculation type that mark cells in the range as dirty for calculation.
rebuild - Rebuild all the formula models in the range and then mark them as dirty for calculation.
minimal - Keep the current cell calculation dirty status.
regular - Mark the volatile and circular reference cells as dirty for calculation.
Broadcasting dirty cells will recursively set the dependents of dirty cells to dirty in the workbook.
The last step is calculate. In automatic mode, all the dirty cells will be calculated.
In manual mode, only the cells in the formula reference are calculated, other cells will keep their dirty state.
For example:
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
//1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const useState = React.useState;
export function AppFunc() {
const [spread, setSpread] = useState(null);
const [calculationType, setCalculationType] = useState(null);
const initSpread = (spread) => {
setSpread(spread);
var sheet = spread.getActiveSheet();
spread.setSheetCount(2);
var sheet2 = spread.sheets[1];
spread.suspendPaint();
spread.suspendCalcService();
spread.options.iterativeCalculationMaximumIterations = 1;
spread.options.iterativeCalculationMaximumChange = 10;
sheet.setValue(0, 0, "Tick:");
sheet.setFormula(0, 1, "=REFRESH(B1+1,2,80)");
sheet.setValue(2, 0, "Value:");
sheet.setFormula(2, 1, "=IFERROR(CHOOSE(MOD(B1,16),5,-5,20,-2),0)+RAND()");
sheet.setValue(0, 4, "Values:");
sheet.getRange(1, 4, 60, 1).formula("=IF(MOD($B$1,60)=(ROW()-2),$B$3,E2)", true);
sheet2.setValue(0, 6, "Values:");
sheet2.getRange(1, 6, 60, 1).formula("=OFFSET(Sheet1!$E$2,MOD(Sheet1!$B$1-1+ROW(),60),0)", true);
sheet.setValue(1, 6, 'Value Sparkline:');
sheet.addSpan(2, 6, 6, 6);
sheet.setFormula(2, 6, '=LINESPARKLINE(E2:E61,0,,,)');
sheet.setValue(10, 6, 'Sheet2 reorder values:');
sheet.addSpan(11, 6, 6, 6);
sheet.setFormula(11, 6, '=LINESPARKLINE(Sheet2!G2:G61,0,,,)');
spread.resumeCalcService();
spread.resumePaint();
}
const enableCalcService = (e) => {
if (e.target.checked) {
spread.resumeCalcService();
} else {
spread.suspendCalcService();
}
}
const calculationMode = (e) => {
if (e.target.value === "0") {
spread.options.calculationMode = GC.Spread.Sheets.CalculationMode.auto;
spread.calculate(false);
} else {
spread.options.calculationMode = GC.Spread.Sheets.CalculationMode.manual;
}
}
const changeType = (e) => {
setCalculationType(GC.Spread.Sheets.CalculationType[e.target.value]);
}
const calculateSpread = (e) => {
spread.calculate(calculationType);
}
const calculateSheet = (e) => {
spread.calculate(calculationType, spread.getActiveSheet().name());
}
const calculateRange = (e) => {
let sheet = spread.getActiveSheet();
let range = sheet.getSelections()[0];
spread.calculate(calculationType, sheet.name() + "!" + GC.Spread.Sheets.CalcEngine.rangeToFormula(range));
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel calculationMode={(e) => { calculationMode(e) }}
enableCalcService={(e) => { enableCalcService(e) }}
changeType={(e) => { changeType(e) }}
calculateSpread={(e) => { calculateSpread(e) }}
calculateSheet={(e) => { calculateSheet(e) }}
calculateRange={(e) => { calculateRange(e) }} />
</div>;
}
function Panel(props) {
return (
<div class="options-container">
<div class="option-row">
<input style={{ width: "20px", float: "left" }} type="checkbox" id="enableCalcService" defaultChecked="checked" onChange={(e) => { props.enableCalcService(e) }} />
<label htmlFor="enableCalcService">enable Calculation Service</label>
</div>
<div className="option-row">
<p>Change the Calculation Mode and input formulas to see the calculation behavior. </p>
<label htmlFor="calculationMode">Calculation Mode</label>
<select id="calculationMode" onChange={e => props.calculationMode(e)}>
<option value="0">Automatic</option>
<option value="1">Manual</option>
</select>
</div>
<div class="option-row">
<p>Check the different calculate scopes with different calculation types in different calculation modes. </p>
<label for="changeType">Calculation Type</label>
<select id="changeType" onChange={e => props.changeType(e)}>
<option value="all">All</option>
<option value="rebuild">Rebuild</option>
<option value="minimal">Minimal</option>
<option value="regular">Regular</option>
</select>
<button id="calculateSpread" onClick={(e) => { props.calculateSpread(e) }} >Calculate Spread</button>
<br />
<button id="calculateSheet" onClick={(e) => { props.calculateSheet(e) }} >Calculate Sheet</button>
<br />
<button id="calculateRange" onClick={(e) => { props.calculateRange(e) }} >Calculate Selection</button>
</div>
</div>
)
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.calculationType = null;
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel calculationMode={(e)=>{this.calculationMode(e)}}
enableCalcService={(e)=>{this.enableCalcService(e)}}
changeType={(e)=>{this.changeType(e)}}
calculateSpread={(e)=>{this.calculateSpread(e)}}
calculateSheet={(e)=>{this.calculateSheet(e)}}
calculateRange={(e)=>{this.calculateRange(e)}}/>
</div>;
}
initSpread(spread) {
this.spread = spread;
var sheet = spread.getActiveSheet();
spread.setSheetCount(2);
var sheet2 = spread.sheets[1];
spread.suspendPaint();
spread.suspendCalcService();
spread.options.iterativeCalculationMaximumIterations = 1;
spread.options.iterativeCalculationMaximumChange = 10;
sheet.setValue(0,0,"Tick:");
sheet.setFormula(0,1,"=REFRESH(B1+1,2,80)");
sheet.setValue(2,0,"Value:");
sheet.setFormula(2,1,"=IFERROR(CHOOSE(MOD(B1,16),5,-5,20,-2),0)+RAND()");
sheet.setValue(0,4,"Values:");
sheet.getRange(1,4,60,1).formula("=IF(MOD($B$1,60)=(ROW()-2),$B$3,E2)", true);
sheet2.setValue(0,6,"Values:");
sheet2.getRange(1,6,60,1).formula("=OFFSET(Sheet1!$E$2,MOD(Sheet1!$B$1-1+ROW(),60),0)", true);
sheet.setValue(1,6,'Value Sparkline:');
sheet.addSpan(2,6,6,6);
sheet.setFormula(2,6,'=LINESPARKLINE(E2:E61,0,,,)');
sheet.setValue(10,6,'Sheet2 reorder values:');
sheet.addSpan(11,6,6,6);
sheet.setFormula(11,6,'=LINESPARKLINE(Sheet2!G2:G61,0,,,)');
spread.resumeCalcService();
spread.resumePaint();
}
enableCalcService(e) {
if (e.target.checked) {
this.spread.resumeCalcService();
} else {
this.spread.suspendCalcService();
}
}
calculationMode(e) {
let spread = this.spread;
if (e.target.value === "0") {
spread.options.calculationMode = GC.Spread.Sheets.CalculationMode.auto;
spread.calculate(false);
} else {
spread.options.calculationMode = GC.Spread.Sheets.CalculationMode.manual;
}
}
changeType(e) {
this.calculationType = GC.Spread.Sheets.CalculationType[e.target.value];
}
calculateSpread(e) {
this.spread.calculate(this.calculationType);
}
calculateSheet(e) {
this.spread.calculate(this.calculationType, this.spread.getActiveSheet().name());
}
calculateRange(e) {
let sheet = this.spread.getActiveSheet();
let range = sheet.getSelections()[0];
this.spread.calculate(this.calculationType, sheet.name()+"!"+GC.Spread.Sheets.CalcEngine.rangeToFormula(range));
}
}
class Panel extends Component{
constructor(props){
super(props);
}
render(){
return(
<div class="options-container">
<div class="option-row">
<input style={{width: "20px", float: "left"}} type="checkbox" id="enableCalcService" defaultChecked="checked" onChange={(e)=>{this.props.enableCalcService(e)}}/>
<label htmlFor="enableCalcService">enable Calculation Service</label>
</div>
<div className="option-row">
<p>Change the Calculation Mode and input formulas to see the calculation behavior. </p>
<label htmlFor="calculationMode">Calculation Mode</label>
<select id="calculationMode" onChange={e => this.props.calculationMode(e)}>
<option value="0">Automatic</option>
<option value="1">Manual</option>
</select>
</div>
<div class="option-row">
<p>Check the different calculate scopes with different calculation types in different calculation modes. </p>
<label for="changeType">Calculation Type</label>
<select id="changeType" onChange={e => this.props.changeType(e)}>
<option value="all">All</option>
<option value="rebuild">Rebuild</option>
<option value="minimal">Minimal</option>
<option value="regular">Regular</option>
</select>
<button id="calculateSpread" onClick={(e)=>{this.props.calculateSpread(e)}} >Calculate Spread</button>
<br />
<button id="calculateSheet" onClick={(e)=>{this.props.calculateSheet(e)}} >Calculate Sheet</button>
<br />
<button id="calculateRange" onClick={(e)=>{this.props.calculateRange(e)}} >Calculate Selection</button>
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
margin-bottom: 5px;
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Suspend Calculation Service
Users can suspend the calculation service for a better experience when calling API in batches.
For example:
Calculation Options
SpreadJS supports a CalculationMode which can be set to manual or automatic.
Automatic Calculation (default)
Calculate all dirty cells every time the relevant data is changed, like when something has been entered or copy-pasted in a cell.
Manual Calculation
Only evaluate a formula when that formula is entered or updated, and keep its dependencies dirty. When cutting/copying-pasting, this mode will set the formula and the cell value, but won’t recalculate any formulas.
Calculate API
You can force calculation by calling the calculate API.
The Calculate function will rebuild, mark dirty, broadcast dirty and calculate the dirty cells.
First rebuild and mark cells in the formula reference as dirty using the calculation type. The list of `GC.Spread.Sheets.CalculationType` is as follows:
all - The default calculation type that mark cells in the range as dirty for calculation.
rebuild - Rebuild all the formula models in the range and then mark them as dirty for calculation.
minimal - Keep the current cell calculation dirty status.
regular - Mark the volatile and circular reference cells as dirty for calculation.
Broadcasting dirty cells will recursively set the dependents of dirty cells to dirty in the workbook.
The last step is calculate. In automatic mode, all the dirty cells will be calculated.
In manual mode, only the cells in the formula reference are calculated, other cells will keep their dirty state.
For example:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
calculationType: GC.Spread.Sheets.CalculationType;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread(e: any) {
this.spread = e.spread;
let spread = this.spread;
let sheet = spread.getActiveSheet();
spread.setSheetCount(2);
let sheet2 = spread.sheets[1];
spread.suspendPaint();
spread.suspendCalcService();
spread.options.iterativeCalculationMaximumIterations = 1;
spread.options.iterativeCalculationMaximumChange = 10;
sheet.setValue(0,0,"Tick:");
sheet.setFormula(0,1,"=REFRESH(B1+1,2,80)");
sheet.setValue(2,0,"Value:");
sheet.setFormula(2,1,"=IFERROR(CHOOSE(MOD(B1,16),5,-5,20,-2),0)+RAND()");
sheet.setValue(0,4,"Values:");
sheet.getRange(1,4,60,1).formula("=IF(MOD($B$1,60)=(ROW()-2),$B$3,E2)", true);
sheet2.setValue(0,6,"Values:");
sheet2.getRange(1,6,60,1).formula("=OFFSET(Sheet1!$E$2,MOD(Sheet1!$B$1-1+ROW(),60),0)", true);
sheet.setValue(1,6,'Value Sparkline:');
sheet.addSpan(2,6,6,6);
sheet.setFormula(2,6,'=LINESPARKLINE(E2:E61,0,,,)');
sheet.setValue(10,6,'Sheet2 reorder values:');
sheet.addSpan(11,6,6,6);
sheet.setFormula(11,6,'=LINESPARKLINE(Sheet2!G2:G61,0,,,)');
spread.resumeCalcService();
spread.resumePaint();
}
enableCalcService(e: any) {
if (e.target.checked) {
this.spread.resumeCalcService();
} else {
this.spread.suspendCalcService();
}
}
calculationMode(e: any) {
let spread = this.spread;
if (e.target.value === "0") {
spread.options.calculationMode = GC.Spread.Sheets.CalculationMode.auto;
spread.calculate(false);
} else {
spread.options.calculationMode = GC.Spread.Sheets.CalculationMode.manual;
}
}
changeType(e: any) {
this.calculationType = GC.Spread.Sheets.CalculationType[e.target.value];
}
calculateSpread(e: any) {
this.spread.calculate(this.calculationType);
}
calculateSheet(e: any) {
this.spread.calculate(this.calculationType, this.spread.getActiveSheet().name());
}
calculateRange(e: any) {
let sheet = this.spread.getActiveSheet();
let range = sheet.getSelections()[0];
this.spread.calculate(this.calculationType, sheet.name()+"!"+GC.Spread.Sheets.CalcEngine.rangeToFormula(range));
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<input style="width: 20px;float: left;" type="checkbox" id="enableCalcService" checked="checked" (change)="enableCalcService($event)" />
<label for="enableCalcService">enable Calculation Service</label>
</div>
<div class="option-row">
<p>Change the Calculation Mode and input formulas to see the calculation behavior. </p>
<label for="calculationMode">Calculation Mode</label>
<select id="calculationMode" (change)="calculationMode($event)">
<option value="0">Automatic</option>
<option value="1">Manual</option>
</select>
</div>
<div class="option-row">
<p>Check the different calculate scopes with different calculation types in different calculation modes. </p>
<label for="changeType">Calculation Type</label>
<select id="changeType" (change)="changeType($event)">
<option value="all">All</option>
<option value="rebuild">Rebuild</option>
<option value="minimal">Minimal</option>
<option value="regular">Regular</option>
</select>
<button id="calculateSpread" (click)="calculateSpread($event)" >Calculate Spread</button>
<br />
<button id="calculateSheet" (click)="calculateSheet($event)" >Calculate Sheet</button>
<br />
<button id="calculateRange" (click)="calculateRange($event)" >Calculate Selection</button>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
margin-bottom: 5px;
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);